"use strict";

var _require = require("react-app-rewired"),
    getLoader = _require.getLoader,
    loaderNameMatches = _require.loaderNameMatches;

var _require2 = require("typescript-plugin-styled-components"),
    createTransformer = _require2.createTransformer;

var tsLoaderMatcher = function tsLoaderMatcher(rule) {
  return loaderNameMatches(rule, "ts-loader");
};
var getTsLoader = function getTsLoader(rules) {
  return getLoader(rules, tsLoaderMatcher);
};

var rewireStyledComponentsTypescriptPlugin = function rewireStyledComponentsTypescriptPlugin(config, _env, options) {
  var tsLoader = getTsLoader(config.module.rules);

  if (!tsLoader) {
    console.error("Skipping styled components typescript plugin: ts-loader not found.");

    return config;
  }

  var styledComponentsTransformer = createTransformer(options);

  tsLoader.options.getCustomTransformers = function () {
    return {
      before: [styledComponentsTransformer]
    };
  };

  return config;
};

module.exports = rewireStyledComponentsTypescriptPlugin;